import java.awt.*;

public class ImageButton extends Canvas
{
	protected	Image	fUpImage = null,
					fDownImage = null;
	protected	boolean	fMouseDown = false;
	protected	String	fLabel;
	
	public ImageButton(Image upimage, Image downimage, String label)
	{
		fLabel = label;
		fUpImage = upimage;
		fDownImage = downimage;
		MediaTracker	mt = new MediaTracker(this);
		mt.addImage(fUpImage, 1);
		mt.addImage(fDownImage, 2);
		
		try
		{	mt.waitForAll();	}
		catch(InterruptedException e)
		{}
	}
	
	private Image currentImage()
	{	return (fMouseDown ? fDownImage : fUpImage);	}
	
	public void paint(Graphics g) 
	{	g.drawImage(currentImage(), 0, 0, this);	}
	
	public void update(Graphics g)
	{	paint(g);	}
	
	public Dimension minimumSize()
	{
		return new Dimension(currentImage().getWidth(this),
						currentImage().getHeight(this));
	}
	
	public Dimension preferredSize()
	{	return minimumSize();	}
	
	public boolean mouseDown(Event e, int x, int y)
	{	
		if (fMouseDown != true)
		{	fMouseDown = true; paint(getGraphics());	}
		return false;	
	}
	
	public boolean mouseUp(Event e, int x, int y)
	{
		if (fMouseDown != false)
		{	
			fMouseDown = false; 
			paint(getGraphics());	
			postEvent(new Event(this, Event.ACTION_EVENT, fLabel));	
		}
		return false;
	}
	
	public boolean mouseDrag(Event e, int x, int y)
	{
		boolean	oldMouse = fMouseDown;
		if (!inside(x, y))
			fMouseDown = false;
		else
			fMouseDown = true;
		if (oldMouse != fMouseDown)
		{
			repaint();
			return true;
		}
		return false;
	}
	
	public boolean mouseExit(Event e, int x, int y)
	{
		if (fMouseDown != false)
		{	fMouseDown = false; paint(getGraphics());	}
		return false;
	}
	
	
}