/*
* @(#)RecordFilter.java	0.1 5/12/97 Kyle Jessup
*	
* Copyright (c) 1997 Blue World Communications, Inc. All Rights Reserved
* 
* Permission to use, copy, modify, and distribute this software
* is hereby granted without fee provided this copyright notice
* appears in all copies.
*
*/

import java.awt.*;

/**
* This class filters LassoRequests to make sure 
* It contains the search criteria specified using 
* two Choices.
*
* @version	0.1, 12 Jun 1997

* @author Kyle Jessup
*/
public class RecordFilter extends GroupBox
{
	protected	Choice	fCategoryFilter = new Choice(),
					fTypeFilter = new Choice();
	protected	String	fCategoryFieldName, 
					fTypeFieldName;
	
	public RecordFilter(	String	catFieldName,
					String[]	catFieldValues,
					String	typeFieldName,
					String[]	typeFieldValues)
	{
		super("Browse By");
		
		fCategoryFieldName = new String(catFieldName);
		fTypeFieldName = new String(typeFieldName);
		
		setLayout(new GridBagLayout());
		
		fCategoryFilter.addItem(new String("Any"));
		for (int i = 0; i < catFieldValues.length; ++i)
			fCategoryFilter.addItem(catFieldValues[i]);
		
		fTypeFilter.addItem(new String("Any"));
		for (int i = 0; i < typeFieldValues.length; ++i)
			fTypeFilter.addItem(typeFieldValues[i]);
		
		GBConstrainer.constrain(this, new Label("Category: ", Label.RIGHT),
							0, 0);

		GBConstrainer.constrain(this, fCategoryFilter, 0, 1);
		GBConstrainer.constrain(this, new Label("Type: ", Label.RIGHT),
							1, 0);
		GBConstrainer.constrain(this, fTypeFilter, 1, 1);			

		repaint();
	}
	
	public void paint(Graphics g)
	{
		super.paint(g);
//		GridBagDebugger.debug(this);
	}
	
	public void filterRequest(LassoRequest r)
	{
		r.removeField(fCategoryFieldName);
		r.removeField(fTypeFieldName);
		
		if (! (fCategoryFilter.getSelectedItem().equals("Any")) )
			r.addField(fCategoryFieldName, fCategoryFilter.getSelectedItem());
		if (! (fTypeFilter.getSelectedItem().equals("Any")) )
			r.addField(fTypeFieldName, fTypeFilter.getSelectedItem());
	}
}
