<!--

This is a sample search file for use with Lasso. Lasso is used in conjunction with Mac OS Web servers to publish FileMaker Pro databases on the web.

Lasso is a product of Blue World Communications, Inc. Information is available at http://www.blueworld.com/lasso/

Lasso operates by interpreting 'Lasso Tags' placed in HTML 'format' files such as this. There are five types of Lasso tags: action, command, substitution, container, and sub-container. Lasso action and command tags are preceded by a dash. While substitution, container, and sub-container are surrounded by square brackets. All Lasso tags are not case sensitive. That is, Lasso will recognize  "-DATABASE" or "-database" "-DaTaBaSe"; or [server_date], [SERVER_DATE], or [SeRveR_dAtE].


-->

<html>
<head>
<title>Lasso - Search Sample Employees Database</title>
</head>
<body bgcolor=#ffffd9>
<center>
<h2>Lasso: Search the Sample Employees Database</h2>

</center>

<P align="center">This is an example of how to use Lasso to search a FileMaker Pro database.
<P align="center">The name of this file is
<strong>Search3.html</strong>; you'll find useful comments in it.
<center>

<!--
The inline tag is used to specify the Lasso action that is to occur. In this case it is simply the "show" action which instructs Lasso to gather information from the specified database.
-->

[inline: database="Employees.fp3",layout="Detail",show]


<!-- Setting action="action.lasso" causes the Web server to direct processing to the Lasso Plug-in or Server. The slash indicates that the Lasso application is located at the root level and all format files should be specified from that location. Without the slash all format files are relative to the base URL-->

<form action="action.lasso" method="POST">

<!-- The "database" tag tells Lasso which FileMaker Pro database to use; the name is not case sensitive. This tag is required. -->

<input type="hidden" name="-database" value="Employees.fp3">

<!-- The "layout" tag tells Lasso which layout in the database to use; the name is not case sensitive. Specifying a layout is optional; if omitted, Lasso will use layout 0 of the database.

If specified, the layout must contain all fields specified in this form, AND all fields specifed in the format file (see discussion of the "-response" tag, below).

Specifying a layout is faster than using layout 0 because Lasso retrieves data for all fields in the layout, even if they're not used in the result page format file. Letting Lasso default to layout 0 is less error prone because it uses all fields in the database.  -->

<input type="hidden" name="-layout" value="Summary">

<!-- The -noResults tag specifies an HTML file for Lasso to display if no records are found as a result of the search. This field is optional. If omitted, Lasso displays a default "No Results" page. -->

<input type="hidden" name="-noResults" value="no_results.html">

<!-- Below here are the input fields for the search values. The names must match the FileMaker Pro field names exactly, but are not case sensitive. Any field can be left blank to tell Lasso to ignore that field.

The [operator] or -operator command tag, which can also be abbreviated [op] or -op, tells Lasso how to compare the value field to find matches. The default is "begins with" (similar to FileMaker Pro's default search operator). If an option list is specified, the default value is the first
				<option> item in the list, unless the attribute 'selected' is used to indicate the default. You may also use operator in a hidden input field if you'd like. The -operator tag only affects the search field that immediately follows. It defaults back to "begins with" after that search field.

The values for -operator must appear exactly as in this example, but are not case sensitive. Alternately, abbreviations may be used for the operator values may be specified in the option tag. This allows use of alternate text to display to the end user. This example uses Lasso abbreviations for the operator values (German translations provided by Marco Galli):

	<select name="-operator">
					<option value="eq"> ist gleich
					<option value="ct"> enthlt
					<option value="bw"> beginnt mit
					<option value="ew"> endet mit
					<option value="gt"> grsser als
					<option value="gte"> grsser als oder gleich
					<option value="lt"> kleiner als
					<option value="lte"> kleiner als oder gleich
			</select>

This form shows examples of text input, menus, and radio buttons to specify field values. -->

<table border=0>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>First Name</b>	</td>
	<td><select name="-op">
					<option>begins with
				<option>equals
				<option>not equals
				<option>contains
				<option>ends with
		</select>
	</td>
	<td><input type=text size=30 name="First Name">	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Last Name</b>	</td>
	<td>	<select name="-op">
				<option>begins with
				<option>equals
				<option>not equals
				<option>contains
				<option>ends with
		</select>
	</td>
	<td><input type=text size=30 name="Last Name">	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Employee Number</b>	</td>

<!-- The operators "contains", "begins with", and "ends with" don't make sense for numeric fields, therefore we don't offer them as options here. Note the use of the HTML encodings &gt; for > and &lt; for
< . -->

	<td><select name="-op">
			<option value="eq" selected> equals
			<option value="neq"> not equals
			<option value="gt"> &gt;
			<option value="gte"> &gt; or =
			<option value="lt"> &lt;
			<option value="lte"> &lt; or =
		</select>
	</td>
	<td><input type=text size=30 name="Employee Number">	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Email</b>	</td>
	<td>	<select name="-op">
					<option>begins with
				<option>equals
				<option>not equals
				<option>contains
				<option>ends with
	</select>
	</td>
	<td><input type=text size=30 name="Email">	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Comments</b>	</td>
	<td>	<select name="-op" size=1>
				<option>contains
				<option>begins with
				<option>equals
				<option>not equals
				<option>ends with
		</select>
	</td>
	<td><input type=text size=30 name="Comments">	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Date Last Modified</b>	</td>
	<td>	<select name="-op">
			<option value="eq"> equals
			<option value="neq"> not equals
			<option value="gt"> &gt;
			<option value="gte" selected> &gt; or =
			<option value="lt"> &lt;
			<option value="lte"> &lt; or =
		</select>
	</td>
	<td><input type=text size=30 name="Edit Date">	</td>
</tr>
<tr>
<!-- The [option: Field Name] tag can be used to format fields that contain value lists as HTML pop-up/pull-down menus. Lasso will substitute HTML in the form:

				<option>List Value

for every value in the value list. Note that a "blank" selection is provided in the pop-up menu so that the user can choose not to specify a value for this field. -->

	<td bgcolor=#d7bf89><p align=right><b>Group</b>	</td>
	<td colspan=2><select name="Group">
			<option value="" selected>None [option: "Group"]
		</select>
	
<!-- Field-level operators are possible using the "-opbegin" and "-opend" tags to specify that whatever is selected for this particular entry, not be included in this search. It is also possible to include two fields and require that they both be included (an "and" logical operator) while the rest of the search form uses the "or" logical operator. -->

&nbsp;<b>Not:</b>
	
	<input type="hidden" name="-opbegin" value="not">
		<select name="Group">
			<option value="" selected>- - omit group - -
		 [option: "Group"]
		</select>
	<input type="hidden" name="-opend">

	</td>
</tr>
<tr>
	<td valign="top" bgcolor=#d7bf89><p align=right>
<b>Shift</b>	</td>
	<td colspan=2>
<input type=radio name="Shift" value="" checked>None [value_list:"Shift"]
<input type="radio" name="Shift" value="[list_value]">[list_value] [/value_list]	
	</td>
</tr>


<tr>
	<td valign="top" bgcolor=#d7bf89><p align=right>
<b>Favorite Colored Dot</b>	</td>
	<td colspan=2>

<input type=hidden name="-op" value="eq">
<input type=radio name="Favorite Colored Dot" value="" checked>None
<input type=radio name="Favorite Colored Dot" value="green_dot.gif">
<img src="green_dot.gif"> Green
<input type=radio name="Favorite Colored Dot" value="purple_dot.gif">
<img src="purple_dot.gif"> Purple
<input type=radio name="Favorite Colored Dot" value="red_dot.gif">
<img src="red_dot.gif"> Red
	</td>
</tr>
<tr>
	<td valign="top" bgcolor=#d7bf89><p align=right>

<!-- The [value_list: Field Name] tag can be used to format fields that contain value lists as a set of radio buttons or checkboxes. All HTML between the [value_list: Field Name] and [/value_list] tags is repeated for every value in the value list. The actual list value is substitued for the [list_value] tag.  -->

<b>Nice Traits</b>	</td>
	<td colspan=2> 
[value_list: "Nice Traits"]
<input type="checkbox" name="Nice Traits" value="[list_value]">[list_value] [/value_list]
	</td>
</tr>


<tr>

<!-- Searches on numeric and date ranges can be accomplished by providing two values for the field with appropriate comparison operators. Note that an operator must be used with fields that are defined as date or time and that only the equals, greater than (equals), or less than (equals) opertors can be used with these type of fields. -->

	<td bgcolor=#d7bf89><p align=right><b>Hire Date</b>	</td>
	<td colspan=2>
<select name="-op">
			<option value="gte"> from
			<option value="gt"> after
		</select>
<input type=text name="Hire Date" size=10>
<select name="-op">
			<option value="lte"> to
			<option value="lt"> before
		</select>
<input type=text name="Hire Date" size=10>
	</td>
</tr>



<tr>	<td colspan=3><hr>	</td></tr>

<tr>

<tr>

<!-- The "logicalop" tag can be used to specify whether Lasso performs an AND or an OR search for all field values. This is an optional tag; if not specified, the default is AND.  -->

	<td bgcolor=#d7bf89><p align=right><b>Logical Operator</b>	</td>
	<td>
<input type=radio name="-logicalop" value="and" checked>AND
<input type=radio name="-logicalop" value="or">OR	</td>

<!-- The "maxRecords" tag limits the number of records returned by Lasso. Specifying "all" tells Lasso to return all records. There is no limit imposed by Lasso on the number of records that can be returned. However, a perception of faster performance will be given by returning a small number of records, and using "[next]" links to view successive pages. See the file "hitlist_format.html" for a discussion of "[next]" links.

The 72K byte limit can be increased by increasing the memory partition in the "Get Info" box for the Web Server. -->

	<td><b>Return</b>
		<select name="-maxRecords">
			<option>5
			<option selected>10
			<option>20
			<option>30
			<option>50
			<option>all
		</select>
<b>records per page
	</td>
</tr>

<!-- The "sortfield" tag tells Lasso which field to sort the results on. It is optional. The value of "Unsorted" (not case sensitive) is recognized by Lasso or the field can be left without any value to leave records unsorted.

There is no limit to the number of sort fields that can be specified by the "sortfield" tag. If multiple tags appear, the sorts will be nested in the order in which they appear on the search form.  -->

<tr>
	<td bgcolor=#d7bf89><p align=right><b>Sort By</b>	</td>
	<td><select name="-sortfield">
				<option VALUE="" SELECTED>- Select -
				<option>unsorted
				<option>First Name
				<option>Last Name
				<option>Employee Number
				<option>Hire Date
				<option>Group
				<option>Shift
		</select>
	</td>

<!-- The -sortordertag applies to the immediately preceding -sortfield. This tag is optional and defaults to "ascending". The value "custom" can be used for fields that contain value list to sort in value list order. -->

	<td><select name="-sortorder">
			<option selected>ascending
				<option>descending
		</select>
	</td>
</tr>
<tr>
	<td bgcolor=#d7bf89><p align=right><b>Sort By</b>	</td>
	<td><select name="-sortfield">
				<option VALUE="" SELECTED>- Select -
				<option>unsorted
				<option>First Name
				<option>Last Name
				<option>Employee Number
				<option>Hire Date
				<option>Group
				<option>Shift
		</select>
	</td>
	<td><select name="-sortorder">
			<option selected>ascending
				<option>descending
		</select>
	</td>
</tr><tr>
	<td bgcolor=#d7bf89><p align=right><b>Response Layout</b>	</td>

	<td colspan="2">
<!-- The "response" tag tells Lasso which format file to use for formatting output. There can be one or more hitlist format files to display the search results. And, the user can be given the option to select which hitlist format file to display. For example, you could have a long form to display a lot of fields, and a short form to display limited fields for a set of records. The following syntax shows how to creating radio buttons for selecting the preferred hitlist.

Alternately, the "response" tag can be specified in a hidden input field if no choice is to be given to the user for formatting search results. -->

<input type=radio name="-response" value="hitlist_format.html" checked>Standard Hitlist  &nbsp; 
<input type=radio name="-response" value="hitlist2_format.html">Alternate Hitlist
	</td>

</tr>
<tr>	<td colspan=3><hr>	</td></tr>
</table>


<p>
<!-- Clicking the "search" button causes Lasso to conduct a database search based on the criteria specified by the user in this form. The value of this button can be anything. -->

<input type="Submit" name="-search" value="Start Search">

<!-- Clicking the "findall" button causes Lasso to return all records in the database, regardless of the criteria specified in this form. The "sortfield," "sortorder," and "maxRecords" values will be applied to the returned records. The value of this button can be anything. -->

<input type="Submit" name="-findall" value="Find All">

<!-- The reset button has no effect on Lasso, it merely clears the current form. Reset does not change field information stored in the FileMaker Pro database -->

<input type="Reset" value="Clear this form">


</form>
</center>

<!-- The [include] tag instructs Lasso to parse and insert the output HTML from the specified format file into the HTML for this format file. -->

<p>
<center>
<b><a href="action.lasso?-database=Employees.fp3&-layout=Detail&-response=Search.html&-show">[ Search Database ]</a></b>  

<b><a href="action.lasso?-database=Employees.fp3&-layout=Detail&-response=Add.html&-show">[ Add Record ]</a></b>

<b><a href="action.lasso?-database=Employees.fp3&-layout=Detail&-response=random_reply.html&-random">[ Get Random Record ]</a></b>

<hr>
<a href="http://www.blueworld.com/lasso/">
<img src="lassologo.gif" border=0 alt="Lasso Home Page"></a>
<hr>
<TABLE>
<TR>
	<TD align=right bgcolor=#d7bf89><B>Client Address:</B></TD>
	<TD bgcolor=#ffffff>[client_addr]</TD>
</TR>
<TR>
	<TD align=right bgcolor=#d7bf89><B>Client IP:</B></TD>
	<TD bgcolor=#ffffff>[client_ip]</TD>
</TR>
<TR>
	<TD align=right bgcolor=#d7bf89><B>Client Type:</B></TD>
	<TD bgcolor=#ffffff>[client_type]</TD>
</TR>
<tr>
	<td align=right bgcolor=#d7bf89><B>Server Date:</B></td>
	<td bgcolor=#ffffff>[server_date, long]</td>
</tr>
<tr>
	<td align=right bgcolor=#d7bf89><B>Server Time:</B></td>
	<td bgcolor=#ffffff>[server_time, long]</td>
</tr>
</TABLE>
</center>

</body>
</html>
[/inline]
