// TextWrapper.java 
// Inserts hard breaks at the specified line width

import java.lang.StringBuffer;
import java.lang.String;

class TextWrapper
{
	public static final String wrap(String input, int wrapAt)
	{
		int	lastWhiteSpace = 0;
		int	currentPosition = 0;
		int	posInLine = 0;
		int	stringLength = input.length();
		StringBuffer	buf = new StringBuffer(input);
		
		try
		{
		
			for (; currentPosition < stringLength; ++currentPosition, ++posInLine)
			{
				if (isWhite(buf.charAt(currentPosition)))
					lastWhiteSpace = currentPosition;
				if (posInLine == wrapAt)
				{
					buf.setCharAt(lastWhiteSpace, '\n');
					posInLine = 0;
				}
				else if (buf.charAt(currentPosition) == '\r') // check cr for Macs
				{
					buf.setCharAt(currentPosition, '\n');
					posInLine = 0;
				}
			}
		
		}
		catch(StringIndexOutOfBoundsException e)
		{	System.err.println(e.toString());	}
		
		return buf.toString();
	}
	
	private static final boolean isWhite(char x)
	{
		return (x == '\t' || x == '\r' || x == '\n' || x == ' ');
	}
	
}